<#ibizinclude>
./CONTROL-BASE.template.ftl
</#ibizinclude>

<#assign import_block>
import moment from 'moment';
</#assign>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    @Prop({ default: true }) protected showBusyIndicator!: boolean;

    /**
     * 当前年份
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected year: number = 0;

    /**
     * 当前月份(0~11)
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected month: number = 0;

    /**
     * 开始时间
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected start: any;
    
    /**
     * 结束时间
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected end: any;

    /**
     * 当前日期
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected currentDate:any = new Date();

    /**
     * 当前天
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected day: number = 0;

    /**
     * 标记数组
     *
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected markDate: Array<any> = [];

    /**
     * 事件时间
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public eventsDate :any = {};


    /**
     * 日历项集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public calendarItems: any = {};

    /**
     * 日历显示状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public show = false;

    /**
     *  选中日期
     * 
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected tileContent: Array<any> = [];

    /**
     *  默认选中
     * 
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected value: Array<any> = [];

    /**
     *  日历样式
     * 
     * @type {Array<any>} 
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected calendarStyle: string = '${ctrl.getCalendarStyle()?lower_case}';


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
      return [];
    }

    
    /**
     * 时间轴加载条数
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */  
    public count :number = 20;

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
      return {};
    }

    /**
     * vue生命周期created
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected created() {
      this.afterCreated();
    }

    /**
     * 处理created之后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected afterCreated() {
        this.initcurrentTime();
        if (this.viewState) {
            this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action, "load")) {
                    this.formatData(this.currentDate, data);
                }
            });
        }
    }
    /**
     * 事件绘制数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public evendata :any = {<#if ctrl.getPSSysCalendarItems()??><#list ctrl.getPSSysCalendarItems() as calendaritem><#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>:[],</#list></#if>}

    /**
     * 激活项
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected activeItem: string = '<#if ctrl.getPSSysCalendarItems()??><#list ctrl.getPSSysCalendarItems() as calendarItem><#if calendarItem_index == 0>${calendarItem.getItemType()?lower_case}<#break></#if></#list></#if>';

    /**
     * 分页节点切换
     *
     * @param {*} $event
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected ionChange($event:any) {
      let { detail: _detail } = $event;
      if (!_detail) {
        return ;
      }
      let { value: _value } = _detail;
      if (!_value) {
        return ;
      }
      this.activeItem = _value;
      this.formatData(new Date(this.year+'/'+(this.month+1)+'/'+this.day));
    }

    /**
     * 查询天数
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected selectday(year: any, month: any, weekIndex: any) {
      this.value = [year, month, this.day];
    }

    /**
     * 上一月事件的回调方法
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected prev(year: any, month: any, weekIndex: any) {
      if(this.calendarStyle == "month_timeline" || this.calendarStyle == "month"){
        this.selectday(year, month, this.day);
        this.formatData(new Date(year+'/'+month+'/'+'1'));
      }
      if(this.calendarStyle == "week_timeline" || this.calendarStyle == "week"){
        this.countWeeks(year,month,weekIndex);
      }
    }

    /**
     * 下一月事件的回调方法
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected next(year: any, month: any, weekIndex: any) {
      if(this.calendarStyle == "month_timeline" || this.calendarStyle == "month" ){
        this.selectday(year, month, this.day);
        this.formatData(new Date(year+'/'+month+'/'+'1'));
      }
      if(this.calendarStyle == "week_timeline" || this.calendarStyle == "week"){
        this.countWeeks(year,month,weekIndex);
      }
    }



    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof Mdctrl
     */
    public async remove(datas: any[]): Promise<any> {
        let arg: any = {};
        let keys: Array<string> = [];
        let infoStr: string = '';
        datas.forEach((data: any, index: number) => {
            keys.push(data.id);
            if (index < 5) {
                if (!Object.is(infoStr, '')) {
                    infoStr += '、';
                }
                infoStr += data.display_name;
            }
        });

        if (datas.length < 5) {
            infoStr = infoStr + ' 共' + datas.length + '条数据';
        } else {
            infoStr = infoStr + '...' + ' 共' + datas.length + '条数据';
        }
        return new Promise((resolve, reject) => {
            const _remove = async () => {
                let _context: any = { mail_activity: keys.join(';') }
                const response: any = await this.service.delete('Remove', Object.assign({}, this.context, _context), arg, this.showBusyIndicator);
                if (response && response.status === 200) {
                    this.$notice.success('删除成功');
                    this.formatData(this.currentDate);
                    resolve(response);
                } else {
                    this.$notice.error(response.message);
                    reject(response);
                }
            }

            this.$dialog.confirm({
                title: '警告',
                message: '确认要删除 ' + infoStr + '，删除操作将不可恢复？',
            }).then(() => {
                _remove();
            }).catch(() => {
            });
        });
    }

    /**
     * 选择年份事件的回调方法
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected selectYear(year: any) {
      this.value = [year, this.month, this.day];
      this.formatData(new Date(year+'/'+this.month+'/'+this.day));
    }

    /**
     * 选择月份事件的回调方法
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected selectMonth(month: any, year: any) {
      this.selectday(year, month, this.day);
      this.formatData(new Date(year+'/'+(month)+'/'+this.day));
    }

    /**
     * 初始化当前时间
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected initcurrentTime() {
      let tempTime = new Date();
      this.year = tempTime.getFullYear();
      this.month = tempTime.getMonth();
      this.day = tempTime.getDate();
    }

    /**
     * 格式化数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected formatData(curtime:any,data: any = {}) {
        this.currentDate = curtime;
        this.year = curtime.getFullYear();
        this.month = curtime.getMonth();
        this.day = curtime.getDate();
        <#if ctrl.getCalendarStyle() == 'DAY'>
        this.start = (moment as any)(curtime).startOf('day').format('YYYY-MM-DD HH:mm:ss');
        this.end = (moment as any)(curtime).endOf('day').format('YYYY-MM-DD HH:mm:ss');
        </#if>
        <#if ctrl.getCalendarStyle() == 'MONTH' || ctrl.getCalendarStyle() == 'MONTH_TIMELINE' || ctrl.getCalendarStyle() == 'TIMELINE'>
        this.start = (moment as any)(curtime).startOf('month').format('YYYY-MM-DD HH:mm:ss');
        this.end = (moment as any)(curtime).endOf('month').format('YYYY-MM-DD HH:mm:ss');
        </#if>
        <#if ctrl.getCalendarStyle() == 'WEEK' || ctrl.getCalendarStyle() == 'WEEK_TIMELINE'>
        this.start = (moment as any)(curtime).startOf('week').format('YYYY-MM-DD HH:mm:ss');
        this.end = (moment as any)(curtime).endOf('week').format('YYYY-MM-DD HH:mm:ss');
        </#if>
        this.load(Object.assign(data, {
          "start": this.start,
          "end": this.end
        }));
    }
<#if ctrl.getCalendarStyle() == "DAY">
    /**
     * 点击前一天
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public prevDate(){ 
        let preDate = new Date(this.currentDate.getTime() - 24*60*60*1000); //前一天
        this.formatData(preDate);
    }

    /**
     * 点击后一天
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public nextDate(){
        let nextDate = new Date(this.currentDate.getTime() + 24*60*60*1000); //后一天
        this.formatData(nextDate);
    }
</#if>

    /**
     * 数据加载
     *
     * @protected
     * @param {*} [opt={}]
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected async load(opt: any = {}): Promise<any> {
        const arg: any = { ...opt };
        const isloading: boolean = this.showBusyIndicator === true ? true : false;
        const response: any = await this.service.search(this.activeItem, { ...this.context }, { ...arg }, this.showBusyIndicator);
        if (response && response.status === 200) {
            this.calendarItems = response.data;
            this.setTileContent();
        } else {
            this.$notice.error('系统异常，请重试!');
        }
        this.show = true;
    }

    

    /**
     * 设置事件数组
     *
     * @protected
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected setTileContent(){
        this.evendata = {<#if ctrl.getPSSysCalendarItems()??><#list ctrl.getPSSysCalendarItems() as calendaritem><#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>:[],</#list></#if>}
        <#if ctrl.getPSSysCalendarItems()??>
        <#list ctrl.getPSSysCalendarItems() as calendaritem>
        if(this.calendarItems.<#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>){
            this.calendarItems.<#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>.forEach((item:any) => {
                if(item.<#if calendaritem.getBeginTimePSAppDEField()?? && calendaritem.getBeginTimePSAppDEField().getName()??>${calendaritem.getBeginTimePSAppDEField().getName()?lower_case}<#else>start</#if>){
                  Object.assign(this.eventsDate,{[item.<#if calendaritem.getBeginTimePSAppDEField()?? && calendaritem.getBeginTimePSAppDEField().getName()??>${calendaritem.getBeginTimePSAppDEField().getName()?lower_case}<#else>start</#if>.substring(0,10)]:"——"});
                  if (this.evendata.<#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>.length > 0) {
                    this.evendata.<#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>.forEach((i: any) => {
                      if (i.time === item.<#if calendaritem.getBeginTimePSAppDEField()?? && calendaritem.getBeginTimePSAppDEField().getName()??>${calendaritem.getBeginTimePSAppDEField().getName()?lower_case}<#else>start</#if>.substring(0, 10)) {
                        if (i.evens) {
                          i.evens.push(item);
                        }
                      } else {
                        this.evendata.<#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>.push({
                          time: item.<#if calendaritem.getBeginTimePSAppDEField()?? && calendaritem.getBeginTimePSAppDEField().getName()??>${calendaritem.getBeginTimePSAppDEField().getName()?lower_case}<#else>start</#if>.substring(0, 10),
                          evens: [item]
                        });
                      }
                    });
                  } else {
                    this.evendata.<#if calendaritem.getItemType()??>${calendaritem.getItemType()?lower_case}</#if>.push({
                      time: item.<#if calendaritem.getBeginTimePSAppDEField()?? && calendaritem.getBeginTimePSAppDEField().getName()??>${calendaritem.getBeginTimePSAppDEField().getName()?lower_case}<#else>start</#if>.substring(0, 10),
                      evens: [item]
                    });
                  }
                }
            });
        }
        </#list>
        </#if>
    }


    /**
     * 日历部件数据选择日期回调
     *
     * @param any 
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected clickDay(data: any) {
      if (data) {
        let temptime = new Date(data);
        this.year = temptime.getFullYear();
        this.month = temptime.getMonth();
        this.day = temptime.getDate();
        this.start = (moment as any)(temptime).startOf('day').format('YYYY-MM-DD HH:mm:ss');
        this.end = (moment as any)(temptime).endOf('day').format('YYYY-MM-DD HH:mm:ss');
        this.load(Object.assign(this.viewparams, { "start": this.start, "end": this.end }));
      }
    }

    /**
     * 日程点击事件
     *
     * @param {*} $event 事件信息
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected getEditView(deName: string) {
        let view: any = {};
        switch(deName){
<#if view.getAllRelatedPSAppViews?? && view.getAllRelatedPSAppViews()??>
  <#list view.getAllRelatedPSAppViews() as editview>
            case "${editview.getPSDataEntity().getCodeName()?lower_case}": 
                view = {
                    viewname: '${srffilepath2(editview.getCodeName())}', 
                    height: ${editview.getHeight()?c}, 
                    width: ${editview.getWidth()?c},  
                    title: '${editview.title}', 
                    placement: '${editview.getOpenMode()}',
                    deResParameters: <#rt>
    <#if editview.isPSDEView()>
      [<#t>
      <#if editview.getPSAppDERSPathCount() gt 0>
        <#list editview.getPSAppDERSPath(editview.getPSAppDERSPathCount() - 1) as deRSPath>
        <#assign majorPSAppDataEntity = deRSPath.getMajorPSAppDataEntity()/><#t>
          { pathName: '${srfpluralize(majorPSAppDataEntity.codeName)?lower_case}', parameterName: '${majorPSAppDataEntity.getCodeName()?lower_case}' }, <#t>
        </#list>
      </#if>
      ],<#lt>
    <#else>
      [],<#lt>
    </#if>
                    parameters: <#rt>
    [<#t>
    <#if editview.isPSDEView() && editview.getPSAppDataEntity()??>
      <#assign appDataEntity = editview.getPSAppDataEntity()/>
      { pathName: '${srfpluralize(appDataEntity.codeName)?lower_case}', parameterName: '${appDataEntity.getCodeName()?lower_case}' }, <#t>
      { pathName: '${editview.getPSDEViewCodeName()?lower_case}', parameterName: '${editview.getPSDEViewCodeName()?lower_case}' } <#t>
    <#else>
      { pathName: '${editview.getCodeName()?lower_case}', parameterName: '${editview.getCodeName()?lower_case}' } <#t>
    </#if>
    ],<#lt>
                };
                break;
  </#list>
</#if>
        }
        return view;
    }

    /**
     * 日程点击事件
     *
     * @param {*} $event 事件信息
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected async onEventClick($event: any): Promise<any> {
        let view: any = {};
        let _context: any = Object.assign({},this.context);
        let itemType = $event.itemType;
        switch(itemType) {
<#if ctrl.getPSSysCalendarItems()??>
  <#list ctrl.getPSSysCalendarItems() as calendarItem>
    <#if calendarItem.getPSAppDataEntity()??>
      <#assign _appde = calendarItem.getPSAppDataEntity() />
            case "${calendarItem.getItemType()}":
                _context.${_appde.getCodeName()?lower_case} = $event.${_appde.getCodeName()?lower_case};
                view = this.getEditView("${_appde.getCodeName()?lower_case}");
                break;
    </#if>
  </#list>
</#if>
        }
        if (Object.is(view.placement, 'INDEXVIEWTAB') || Object.is(view.placement, '')) {
            const routePath = this.$viewTool.buildUpRoutePath(this.$route, this.context, view.deResParameters, view.parameters, [JSON.parse(JSON.stringify(_context))] , JSON.parse(JSON.stringify(this.viewparams)));
            this.$router.push(routePath);
        } else {
            let container: Subject<any> = new Subject();
            if (Object.is(view.placement, 'POPUPMODAL')) {
                container = await this.$appmodal.openModal(view,  JSON.parse(JSON.stringify(_context)),  JSON.parse(JSON.stringify(this.viewparams)));
            } else if (view.placement.startsWith('DRAWER')) {
                container = this.$appdrawer.openDrawer(view,  JSON.parse(JSON.stringify(_context)),  JSON.parse(JSON.stringify(this.viewparams)));
            }
            container.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                // 刷新日历
                this.load(Object.assign(this.viewparams, { "start": this.start, "end": this.end }));
            });
        }
    }
    /**
     * 根据周下标计算事件
     *
     * @param {*} $event 事件信息
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public countWeeks(year: any, month: any, week: any) {
        let date = new Date(year + '/' + month + '/' + 1);
        let weekline = date.getDay();
        if(weekline == 0){
          this.formatData(new Date(year + '/' + month + '/' + (week*7 +1)));
        }else{
          this.formatData(new Date(year + '/' + month + '/' + (week*7 - weekline + 1)));
        }
    }
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>