<#assign extendsClass>CalendarServiceBase</#assign>
<#ibizinclude>
../@MACRO/SERVICE/SERVICE_HEADER.ts.ftl
</#ibizinclude>

    /**
     * 事件配置集合
     *
     * @protected
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected eventsConfig: any = {
<#if ctrl.getPSSysCalendarItems()??>
    <#list ctrl.getPSSysCalendarItems() as calendarItem>
        <#if calendarItem.getPSAppDataEntity()?? && calendarItem.getPSDEDataSet()??>
        '${calendarItem.getItemType()?lower_case}': {
            itemName : '${calendarItem.getName()}',
            itemType : '${calendarItem.getItemType()?lower_case}',
            color : '${calendarItem.getBKColor()}',
            textColor : '${calendarItem.getColor()}',
        },
        </#if>
    </#list>
</#if>
    };

    /**
     * 查询数据
     *
     * @param {string} itemType
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isLoading]
     * @returns {Promise<HttpResponse>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    public async search(itemType: string, context: any = {}, data: any = {}, isLoading?: boolean): Promise<HttpResponse> {
        let item: any = {};
        let action: string = '';
        this.model.itemType = itemType;
        try {
            switch (itemType) {
<#if ctrl.getPSSysCalendarItems()??>
     <#list ctrl.getPSSysCalendarItems() as calendarItem>
        <#if calendarItem.getPSAppDataEntity()?? && calendarItem.getPSDEDataSet()??>
            <#assign _appde = calendarItem.getPSAppDataEntity() />
            <#assign deDataSet = calendarItem.getPSDEDataSet() />
                case "${calendarItem.getItemType()?lower_case}":
                    action = 'Fetch${deDataSet.getCodeName()}';
                    data = this.handleRequestData(action, context, data);
                    await this.onBeforeAction(action, context, data, isLoading);
                <#if _appde.getId() == appde.getId()>
                    item = {
                        ...{ ${calendarItem.getItemType()?lower_case}: await this.loadDEDataSet(action, context, data, '${calendarItem.getItemType()?lower_case}') },
                    };
                <#else>
                    item = {
                        ...{ ${calendarItem.getItemType()?lower_case}: await this.loadDEDataSet(action, context, data, '${calendarItem.getItemType()?lower_case}', '${_appde.getCodeName()?lower_case}') },
                    };
                </#if>
                    break;
        </#if>
     </#list>
</#if>
            };
        } catch (response) {
            await this.onAfterAction(action, context, response);
            return new HttpResponse(response.status);
        }
        await this.onAfterAction(action, context);
        return new HttpResponse(200, item);
    }

    /**
     * 修改数据
     *
     * @param {string} action
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isLoading]
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    public async update(itemType: string, context: any = {}, data: any = {}, isLoading?: boolean): Promise<any> {
        await this.onBeforeAction('', context, data, isLoading);
        data = this.handleRequestData('', context, data);
        let response: any;
        switch (itemType) {
<#if ctrl.getPSSysCalendarItems()??>
  <#list ctrl.getPSSysCalendarItems() as calendarItem>
    <#if calendarItem.getPSAppDataEntity()??>
      <#assign _appde = calendarItem.getPSAppDataEntity() />
        <#if _appde.getId() == appde.getId()>
            case "${calendarItem.getItemType()}":
                response = await this.service.Update(context, data);
                break;
        <#else>
            case "${calendarItem.getItemType()}":
                response = await this.getService('${_appde.getCodeName()?lower_case}').then((s: any) => s.Update(context, data));
                break;
        </#if>
    </#if>
  </#list>
</#if>
        }
        if (!response.isError()) {
            response = this.handleResponse("", response);
        }
        await this.onAfterAction('', context, response);
        return new HttpResponse(response.status, response.data);
    }

<#ibizinclude>
../@MACRO/SERVICE/SERVICE_BOTTOM.ts.ftl
</#ibizinclude>